"""
Streamlit Application
Loïc Chapron
Marie FU
"""

from altair import DataFormat
import streamlit as st
import pandas as pd
from src.gerneralFileOP import *
import src.basic as tmp

STATE = st.session_state

tmp.base("GarganTextJsonToTSV")

def getText(corpusJson: pd.DataFrame) -> str:

    output = "title\tsource\tpublication_year\tpublication_month\tpublication_day\tabstract\tauthors\n"

    for row in corpusJson['documents']:
        doc = row['document']['hyperdata']
        abstract = "empty"
        authors = "empty"
        title = "empty"
        source = "empty"

        if 'title' in doc.keys():
            if doc['title'] != "":
                title = doc['title']

        if 'source' in doc.keys():
            if doc['source'] != "":
                source = doc['source']

        if 'abstract' in doc.keys():
            if doc['abstract'] != "":
                abstract = doc['abstract']

        if 'authors' in doc.keys():
            if doc['authors'] != "":
                authors = doc['authors']

        output += (title + "\t" + source + "\t" + str(doc['publication_year']) + "\t" + str(
            doc['publication_month']) + "\t" + str(doc['publication_day']) + "\t" + abstract + "\t" + authors).replace("\n"," ") + "\n"

    return output


st.write(st.session_state.general_text_dict['text'])

# input for a new file name
STATE.newFileName = st.text_input(label=st.session_state.general_text_dict['file_name_input'],placeholder="File.tsv")

file = st.file_uploader(
    st.session_state.general_text_dict['file'], type=["json"], key='file')

if file:
    # first utilisation of errMessageLog, contain the log of every error message encountered
    STATE.errMessageLog = ""

    # check new file name given by user
    STATE.newFileName = checkNewFileName(STATE.newFileName, STATE.file.name)
    if STATE.newFileName is None:
        STATE.errMessageLog += st.session_state.general_text_dict['err_file_name']
        errDisplay(STATE.errMessageLog)
    else:
        try:
            df = pd.read_json(file)

            show_download_button(STATE.newFileName,getText(df))
        except Exception as e:
            STATE.errMessageLog += st.session_state.general_text_dict['error']
            errDisplay(STATE.errMessageLog)
    file.close()
